「程式碼隨想錄演算法訓練營」第二十九天 | 動態規劃 part2

云雀AC了一整天發表於2024-08-05

62. 不同路徑

題目連結:https://leetcode.cn/problems/unique-paths/
題目難度:中等
文章講解:https://programmercarl.com/0062.不同路徑.html
影片講解:https://www.bilibili.com/video/BV1ve4y1x7Eu/
題目狀態:還是想不出 dp 陣列,看題解了

思路:

首先構建一個 dp 陣列,這次是一個二維陣列,dp[i][j] 表示從 (0, 0) 到 (i, j)的路徑個數。很容易想到:dp[1][j] 的個數是由 dp[i - 1][j] + dp[i] [j - 1] 得來的,且在路徑邊緣只需要一條路徑就能到達,因此整體路徑的個數如下圖所示:

image

程式碼:

class Solution {
public:
    int uniquePaths(int m, int n) {
        vector<vector<int>> dp(m, vector<int>(n, 0));
        for(int i = 0; i < m; ++i) dp[i][0] = 1;
        for(int j = 0; j < n; ++j) dp[0][j] = 1;
        for(int i = 1; i < m; ++i) {
            for(int j = 1; j < n; ++j) {
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            }
        }
        return dp[m - 1][n - 1];
    }
};

63. 不同路徑 II

題目連結:https://leetcode.cn/problems/unique-paths-ii/
題目難度:中等
文章講解:https://programmercarl.com/0063.不同路徑II.html
影片講解:https://www.bilibili.com/video/BV1Ld4y1k7c6/
題目狀態:能想到怎麼解,但引數輸入給我看懵了

思路:

和上面一題思路差不多,只不過是要判斷一下當前位置是否有障礙物,若有障礙物就過不來,因此到達障礙物的路徑依舊是0,還要注意的一點是,若在邊緣中某一位置出現在障礙物,則該位置到其後面一直都過不去,因此後面一直都是 0 。

image

程式碼:

class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        int m = obstacleGrid.size();
        int n = obstacleGrid[0].size();
        if(obstacleGrid[m - 1][n - 1] == 1 || obstacleGrid[0][0] == 1)
            return 0;
        vector<vector<int>> dp(m, vector<int>(n, 0));
        for(int i = 0; i < m && obstacleGrid[i][0] == 0; ++i) dp[i][0] = 1;
        for(int j = 0; j < n && obstacleGrid[0][j] == 0; ++j) dp[0][j] = 1;
        for(int i = 1; i < m; ++i) {
            for(int j = 1; j < n; ++j) {
                if(obstacleGrid[i][j] == 1) continue;
                dp[i][j] = dp[i - 1][j] + dp[i][j - 1];
            }
        }
        return dp[m - 1][n - 1];
    }
};

343. 整數拆分

題目連結:https://leetcode.cn/problems/integer-break/
題目難度:中等
文章講解:https://programmercarl.com/0343.整數拆分.html
影片講解:https://www.bilibili.com/video/BV1Mg411q7YJ/
題目狀態:看題解了

思路:

分開遍歷整數,將其拆為 i 和 j,結果為 i * j,找到 i * j 的最大值。而後面一個整數的乘積也可以透過前一個拆分出來的整數的乘積最大值再乘剩餘的部分得出。

程式碼:

class Solution {
public:
    int integerBreak(int n) {
        vector<int> dp(n + 1);
        dp[2] = 1;
        for(int i = 3; i <= n; ++i) {
            for(int j = 1; j <= i / 2; ++j) {
                dp[i] = max(dp[i], max((i - j) * j, dp[i - j] * j));
            }
        }
        return dp[n];
    }
};

也可以使用貪心演算法,但是沒有看太懂,程式碼如下:

class Solution {
public:
    int integerBreak(int n) {
        if (n == 2) return 1;
        if (n == 3) return 2;
        if (n == 4) return 4;
        int result = 1;
        while (n > 4) {
            result *= 3;
            n -= 3;
        }
        result *= n;
        return result;
    }
};

96. 不同的二叉搜尋樹

題目連結:https://leetcode.cn/problems/unique-binary-search-trees/
題目難度:中等
文章講解:https://programmercarl.com/0096.不同的二叉搜尋樹.html
影片講解:https://www.bilibili.com/video/BV1eK411o7QA/
題目狀態:看完題一點思路沒有,看題解

思路:

將二叉搜尋樹拆分,按其左右子樹分別往下拆,最後將左右子樹得到的二叉搜尋樹的個數相加獲得。

程式碼:

class Solution {
public:
    int numTrees(int n) {
        vector<int> dp(n + 1);
        dp[0] = 1;
        for(int i = 1; i <= n; ++i) {
            for(int j = 1; j <= i; ++j) {
                dp[i] += dp[j - 1] * dp[i - j];
            }
        }
        return dp[n];
    }
};

相關文章